<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2 Final//EN">
<html>
<head>
<title>/home/tylerwbrown/Code/Challenges/Haskell/non_divisible_subset.hs</title>
</head>
<head>
<link type='text/css' rel='stylesheet' href='liquid.css' />
</head>

<body>
<hr>
Put mouse over identifiers to see inferred types
<pre><span class=hs-linenum> 1: </span><span class='hs-comment'>{-# LANGUAGE FlexibleInstances, UndecidableInstances, DuplicateRecordFields #-}</span>
<span class=hs-linenum> 2: </span>
<span class=hs-linenum> 3: </span><span class='hs-keyword'>module</span> <span class='hs-conid'>Main</span> <span class='hs-keyword'>where</span>
<span class=hs-linenum> 4: </span>
<span class=hs-linenum> 5: </span><span class='hs-keyword'>import</span> <span class='hs-conid'>Control.Monad</span>
<span class=hs-linenum> 6: </span><span class='hs-keyword'>import</span> <span class='hs-conid'>Data.Array</span>
<span class=hs-linenum> 7: </span><span class='hs-keyword'>import</span> <span class='hs-conid'>Data.Bits</span>
<span class=hs-linenum> 8: </span><span class='hs-keyword'>import</span> <span class='hs-conid'>Data.List</span>
<span class=hs-linenum> 9: </span><span class='hs-keyword'>import</span> <span class='hs-conid'>Data.List.Split</span>
<span class=hs-linenum>10: </span><span class='hs-keyword'>import</span> <span class='hs-conid'>Debug.Trace</span>
<span class=hs-linenum>11: </span><span class='hs-keyword'>import</span> <span class='hs-conid'>System.Environment</span>
<span class=hs-linenum>12: </span><span class='hs-keyword'>import</span> <span class='hs-conid'>System.IO</span>
<span class=hs-linenum>13: </span><span class='hs-keyword'>import</span> <span class='hs-conid'>System.IO.Unsafe</span>
<span class=hs-linenum>14: </span>
<span class=hs-linenum>15: </span><span class='hs-layout'>(</span><span class='hs-varop'>|&gt;</span><span class='hs-layout'>)</span> <span class='hs-varid'>x</span> <span class='hs-varid'>f</span> <span class='hs-keyglyph'>=</span> <span class='hs-varid'>f</span> <span class='hs-varid'>x</span>
<span class=hs-linenum>16: </span>
<span class=hs-linenum>17: </span><span class='hs-keyword'>{-@</span> <span class='hs-varid'>perm</span> <span class='hs-keyglyph'>::</span> <span class='hs-keyword'>{xs:</span><span class='hs-keyglyph'>[</span><span class='hs-varid'>a</span><span class='hs-keyglyph'>]</span> <span class='hs-keyword'>| (length xs) &gt; 0}</span> <span class='hs-keyglyph'>-&gt;</span> <span class='hs-conid'>Int</span> <span class='hs-keyword'>@-}</span>
<span class=hs-linenum>18: </span><span class='hs-definition'>perm</span> <span class='hs-varid'>xs</span> <span class='hs-keyglyph'>=</span> <span class=hs-error><span class='hs-varid'>tak</span></span>
<span class=hs-linenum>19: </span>
<span class=hs-linenum>20: </span>  
<span class=hs-linenum>21: </span><span class='hs-definition'>nonDivisibleSubset</span> <span class='hs-varid'>k</span> <span class='hs-varid'>s</span> <span class='hs-keyglyph'>=</span> <span class='hs-str'>"yeet"</span> <span class='hs-comment'>-- |&gt;</span>
<span class=hs-linenum>22: </span>  <span class='hs-comment'>-- filter (\(x, y) -&gt; (x + y) `mod` k) |&gt;</span>
<span class=hs-linenum>23: </span> 
<span class=hs-linenum>24: </span>
<span class=hs-linenum>25: </span><span class='hs-definition'>readMultipleLinesAsStringArray</span> <span class='hs-num'>0</span> <span class='hs-keyglyph'>=</span> <span class='hs-varid'>return</span> <span class='hs-conid'>[]</span>
<span class=hs-linenum>26: </span><span class='hs-definition'>readMultipleLinesAsStringArray</span> <span class='hs-varid'>n</span> <span class='hs-keyglyph'>=</span> <span class='hs-keyword'>do</span>
<span class=hs-linenum>27: </span>    <span class='hs-varid'>line</span> <span class='hs-keyglyph'>&lt;-</span> <span class='hs-varid'>getLine</span>
<span class=hs-linenum>28: </span>    <span class='hs-varid'>rest</span> <span class='hs-keyglyph'>&lt;-</span> <span class='hs-varid'>readMultipleLinesAsStringArray</span><span class='hs-layout'>(</span><span class='hs-varid'>n</span> <span class='hs-comment'>-</span> <span class='hs-num'>1</span><span class='hs-layout'>)</span>
<span class=hs-linenum>29: </span>    <span class='hs-varid'>return</span> <span class='hs-layout'>(</span><span class='hs-varid'>line</span> <span class='hs-conop'>:</span> <span class='hs-varid'>rest</span><span class='hs-layout'>)</span>
<span class=hs-linenum>30: </span>
<span class=hs-linenum>31: </span><span class='hs-definition'>main</span> <span class='hs-keyglyph'>=</span> <span class='hs-keyword'>do</span>
<span class=hs-linenum>32: </span>    <span class='hs-varid'>stdout</span> <span class='hs-keyglyph'>&lt;-</span> <span class='hs-varid'>getEnv</span> <span class='hs-str'>"OUTPUT_PATH"</span>
<span class=hs-linenum>33: </span>    <span class='hs-varid'>fptr</span> <span class='hs-keyglyph'>&lt;-</span> <span class='hs-varid'>openFile</span> <span class='hs-varid'>stdout</span> <span class='hs-conid'>WriteMode</span>
<span class=hs-linenum>34: </span>
<span class=hs-linenum>35: </span>    <span class='hs-varid'>nkTemp</span> <span class='hs-keyglyph'>&lt;-</span> <span class='hs-varid'>getLine</span>
<span class=hs-linenum>36: </span>    <span class='hs-keyword'>let</span> <span class='hs-varid'>nk</span> <span class='hs-keyglyph'>=</span> <span class='hs-varid'>words</span> <span class='hs-varid'>nkTemp</span>
<span class=hs-linenum>37: </span>
<span class=hs-linenum>38: </span>    <span class='hs-keyword'>let</span> <span class='hs-varid'>n</span> <span class='hs-keyglyph'>=</span> <span class='hs-varid'>read</span> <span class='hs-layout'>(</span><span class='hs-varid'>nk</span> <span class='hs-varop'>!!</span> <span class='hs-num'>0</span><span class='hs-layout'>)</span> <span class='hs-keyglyph'>::</span> <span class='hs-conid'>Int</span>
<span class=hs-linenum>39: </span>    <span class='hs-keyword'>let</span> <span class='hs-varid'>k</span> <span class='hs-keyglyph'>=</span> <span class='hs-varid'>read</span> <span class='hs-layout'>(</span><span class='hs-varid'>nk</span> <span class='hs-varop'>!!</span> <span class='hs-num'>1</span><span class='hs-layout'>)</span> <span class='hs-keyglyph'>::</span> <span class='hs-conid'>Int</span>
<span class=hs-linenum>40: </span>
<span class=hs-linenum>41: </span>    <span class='hs-varid'>sTemp</span> <span class='hs-keyglyph'>&lt;-</span> <span class='hs-varid'>getLine</span>
<span class=hs-linenum>42: </span>    <span class='hs-keyword'>let</span> <span class='hs-varid'>s</span> <span class='hs-keyglyph'>=</span> <span class='hs-conid'>Data.List.map</span> <span class='hs-layout'>(</span><span class='hs-varid'>read</span> <span class='hs-keyglyph'>::</span> <span class='hs-conid'>String</span> <span class='hs-keyglyph'>-&gt;</span> <span class='hs-conid'>Int</span><span class='hs-layout'>)</span> <span class='hs-varop'>.</span> <span class='hs-varid'>words</span> <span class='hs-varop'>$</span> <span class='hs-varid'>sTemp</span>
<span class=hs-linenum>43: </span>
<span class=hs-linenum>44: </span>    <span class='hs-keyword'>let</span> <span class='hs-varid'>result</span> <span class='hs-keyglyph'>=</span> <span class='hs-varid'>nonDivisibleSubset</span> <span class='hs-varid'>k</span> <span class='hs-varid'>s</span>
<span class=hs-linenum>45: </span>    <span class='hs-varid'>hPutStrLn</span> <span class='hs-varid'>fptr</span> <span class='hs-varop'>$</span> <span class='hs-varid'>show</span> <span class='hs-varid'>result</span>
<span class=hs-linenum>46: </span>
<span class=hs-linenum>47: </span>    <span class='hs-varid'>hFlush</span> <span class='hs-varid'>fptr</span>
<span class=hs-linenum>48: </span>    <span class='hs-varid'>hClose</span> <span class='hs-varid'>fptr</span>
<span class=hs-linenum>49: </span>
</pre>
</body>
</html>